# KitQL

[KitQL](https://github.com/jycouet/kitql#kitql), _A set of tools, helping **you** building efficient apps in a fast way._

<p align="center">
  <img src="./logo.svg" width="100" />
</p>

![svelte](https://img.shields.io/badge/powered%20by-SvelteKit-FF3C02.svg?style=flat&logo=svelte)
![graphql](https://img.shields.io/badge/powered%20by-GraphQL-E10098.svg?style=flat&logo=graphql&logoColor=E10098)
![ts](https://img.shields.io/badge/language-typescript-blue.svg?style=flat&logo=typescript)

[![NPM version](https://img.shields.io/npm/v/@kitql/all-in?color=grean&label=@kitql/all-in)](https://www.npmjs.com/package/@kitql/all-in)
[![Release](https://github.com/jycouet/kitql/actions/workflows/release.yml/badge.svg)](https://github.com/jycouet/kitql/actions/workflows/release.yml)
[![Tests](https://github.com/jycouet/kitql/actions/workflows/ci.yml/badge.svg)](https://github.com/jycouet/kitql/actions/workflows/ci.yml)
![check-code-coverage](https://img.shields.io/badge/code--coverage-80.79%25-green)

<br />

# 🌐 Infos

- Documentation: [https://kitql.dev](https://kitql.dev)
- Day by day progress, check [twitter - jycouet](https://twitter.com/jycouet/status/1486052645567672324)
- Video 👇
  <a href="https://www.youtube.com/watch?v=Ggz5cvxDwFs" target="_blank">
  <img src="https://img.youtube.com/vi/Ggz5cvxDwFs/0.jpg" alt="Watch the video" width="100%" />
  </a>

<br />

# ⚡How to start?

You have 3 main options to use `KitQL`:

- Take a [Demo App](https://kitql.dev/docs/demos/01_demo-01) and tweak it to your needs
- Follow the [KitQL - all-in](https://kitql.dev/docs/demos/01_demo-01) guide (easy)
- Pick and choose the tools you need (advanced)
  - [KitQL - client](https://github.com/jycouet/kitql/tree/main/packages/client)
  - [KitQL - graphql-codegen](https://github.com/jycouet/kitql/tree/main/packages/graphql-codegen)
  - [KitQL - vite-plugin-watch-and-run](https://github.com/jycouet/kitql/tree/main/packages/vite-plugin-watch-and-run)

<br />

<br /><br />

# ⚒️ Tools involved

- ✅ [SvelteKit](https://kit.svelte.dev/)
- ✅ [GraphQL](https://graphql.org/)
- ✅ [GraphQL - CodeGen](https://www.graphql-code-generator.com/)
- ✅ [GraphQL - Yoga](https://www.graphql-yoga.com/)

<br /><br />

# 🆓 License

[![GitHub license](https://img.shields.io/badge/license-MIT-gree.svg)](./LICENSE)

## ✨ Contributors

<!-- ALL-CONTRIBUTORS-BADGE:START - Do not remove or modify this section -->
[![All Contributors](https://img.shields.io/badge/all_contributors-20-orange.svg)](#contributors)
<!-- ALL-CONTRIBUTORS-BADGE:END -->

Thanks goes to these wonderful people ([emoji key](https://allcontributors.org/docs/en/emoji-key)):

<!-- ALL-CONTRIBUTORS-LIST:START - Do not remove or modify this section -->
<!-- prettier-ignore-start -->
<!-- markdownlint-disable -->
<table>
  <tbody>
    <tr>
      <td align="center"><a href="http://www.dynamicprocess.io"><img src="https://avatars.githubusercontent.com/u/5312607?v=4" width="100px;" alt=""/><br /><sub><b>JYC</b></sub></a></td>
      <td align="center"><a href="http://linkedin.com/in/julian-bruxelle"><img src="https://avatars.githubusercontent.com/u/36154424?v=4" width="100px;" alt=""/><br /><sub><b>Julian BRUXELLE</b></sub></a></td>
      <td align="center"><a href="https://github.com/richarddavenport"><img src="https://avatars.githubusercontent.com/u/3596012?v=4" width="100px;" alt=""/><br /><sub><b>Richard Davenport</b></sub></a></td>
      <td align="center"><a href="https://github.com/cya"><img src="https://avatars.githubusercontent.com/u/795915?v=4" width="100px;" alt=""/><br /><sub><b>Yuriy Chertkov</b></sub></a></td>
      <td align="center"><a href="https://github.com/frederikhors"><img src="https://avatars.githubusercontent.com/u/41120635?v=4" width="100px;" alt=""/><br /><sub><b>frederikhors</b></sub></a></td>
      <td align="center"><a href="https://scottspence.com"><img src="https://avatars.githubusercontent.com/u/234708?v=4" width="100px;" alt=""/><br /><sub><b>Scott Spence</b></sub></a></td>
      <td align="center"><a href="http://szery.net.pl"><img src="https://avatars.githubusercontent.com/u/4786095?v=4" width="100px;" alt=""/><br /><sub><b>Łukasz Wiśniewski</b></sub></a></td>
    </tr>
    <tr>
      <td align="center"><a href="https://github.com/AlexanderBacklund"><img src="https://avatars.githubusercontent.com/u/22005025?v=4" width="100px;" alt=""/><br /><sub><b>Alexander Backlund</b></sub></a></td>
      <td align="center"><a href="https://graphql.wtf"><img src="https://avatars.githubusercontent.com/u/950181?v=4" width="100px;" alt=""/><br /><sub><b>Jamie Barton</b></sub></a></td>
      <td align="center"><a href="https://github.com/gregoryforel"><img src="https://avatars.githubusercontent.com/u/4669234?v=4" width="100px;" alt=""/><br /><sub><b>GregFo</b></sub></a></td>
      <td align="center"><a href="https://github.com/scottBowles"><img src="https://avatars.githubusercontent.com/u/59491167?v=4" width="100px;" alt=""/><br /><sub><b>Scott Bowles</b></sub></a></td>
      <td align="center"><a href="http://happycollision.com"><img src="https://avatars.githubusercontent.com/u/3663628?v=4" width="100px;" alt=""/><br /><sub><b>Don Denton</b></sub></a></td>
      <td align="center"><a href="https://github.com/B2o5T"><img src="https://avatars.githubusercontent.com/u/7361780?v=4" width="100px;" alt=""/><br /><sub><b>Dimitri POSTOLOV</b></sub></a></td>
      <td align="center"><a href="https://github.com/nikfp"><img src="https://avatars.githubusercontent.com/u/46945607?v=4" width="100px;" alt=""/><br /><sub><b>Nik F P</b></sub></a></td>
    </tr>
    <tr>
      <td align="center"><a href="https://github.com/dminikm"><img src="https://avatars.githubusercontent.com/u/9631648?v=4" width="100px;" alt=""/><br /><sub><b>Dominik Meca</b></sub></a></td>
      <td align="center"><a href="https://github.com/Giovannini"><img src="https://avatars.githubusercontent.com/u/5586669?v=4" width="100px;" alt=""/><br /><sub><b>Thomas GIOVANNINI</b></sub></a></td>
      <td align="center"><a href="https://github.com/Nukiloco"><img src="https://avatars.githubusercontent.com/u/16618467?v=4" width="100px;" alt=""/><br /><sub><b>Nukiloco</b></sub></a></td>
      <td align="center"><a href="http://danielsalvado.com"><img src="https://avatars.githubusercontent.com/u/9869755?v=4" width="100px;" alt=""/><br /><sub><b>Daniel Salvado</b></sub></a></td>
      <td align="center"><a href="https://github.com/dztek"><img src="https://avatars.githubusercontent.com/u/94202437?v=4" width="100px;" alt=""/><br /><sub><b>dztek</b></sub></a></td>
      <td align="center"><a href="https://github.com/david-plugge"><img src="https://avatars.githubusercontent.com/u/59972093?v=4" width="100px;" alt=""/><br /><sub><b>David Plugge</b></sub></a></td>
    </tr>
  </tbody>
</table>

<!-- markdownlint-restore -->
<!-- prettier-ignore-end -->

<!-- ALL-CONTRIBUTORS-LIST:END -->

Wanna contribute? More info on [this page](./CONTRIBUTING.md)
